#!/bin/bash
#
#   INSTALL.sh      script di installazione per la 
#   Vers. 0.0.5   segreteria telefonica via web.           
#                 Copyright (C)  2002-2004  Matteo Nastasi 
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#     CONTACT:    nastasi@alternativeoutput.it
#                 matteo.nastasi@milug.org

#set -x
#export STEPBYSTEP=1
# indirizzi di posta a cui volete venga inviata mail 
# quando arriva un nuovo messaggio (separati da spazio)
ADMIN=root

# path dove copiare lo script makewavmsg.sh
MAKEMSG_PATH=/usr/local/sbin

# ogni quanto tempo riscandire la directory
OGNIQUANTO=2

# file di configurazione di vgetty
VGETTYCONF=/etc/mgetty/voice.conf

# file temporaneo di lavoro
TMPFILE=/tmp/install_segre.$$.tmp

# directory dove installare i file per il web
PHPFILEPATH=/path/dove/salvare/gli/script.php

#
#  FUNZIONI
#
function checkroot () {
  if [ "`id -u`" != "0" ]; then
     echo "occorre essere root per lanciare questo script"
     return 1
  else
     return 0
  fi
}

#
#  MAIN
#
# verifica se si e' root
checkroot
if [ $? -ne 0 ]; then
   exit 1
fi

# verifica esistenza directory dove collocare i file php
if [ ! -d $PHPFILEPATH ]; then
   echo "directory $PHPFILEPATH non esiste"
   exit 1
fi

test $STEPBYSTEP && read a

# verifica esistenza file di config di vgetty
if [ ! -f $VGETTYCONF ]; then
   echo "File $VGETTYCONF non trovato"
   exit 1
fi

test $STEPBYSTEP && read a
# acquisisce il gruppo con cui vengono salvati i messaggi
vgettygroup="`grep '^voice_group' $VGETTYCONF | cut -d ' ' -f 2`"
if [ $? -ne 0 ]; then
   echo "gruppo voice_group non trovato in $VGETTYCONF"
   exit 1
fi

test $STEPBYSTEP && read a
# acquisisce il gruppo con cui vengono salvati i messaggi
vgettydir="`grep '^voice_dir' $VGETTYCONF | cut -d ' ' -f 2`"
if [ $? -ne 0 ]; then
   echo "directory voice_dir non trovata in $VGETTYCONF"
   exit 1
fi

test $STEPBYSTEP && read a
wavdir=$vgettydir/incomwav
if [ ! -d $wavdir ]; then
   mkdir $wavdir
   chgrp $vgettygroup $wavdir
   chmod 775 $wavdir
   chmod g+s $wavdir
fi
test $STEPBYSTEP && read a

# verifica che apache stia girando
ps aux | grep 'apache$' | grep -v '^root' >/dev/null 2>&1
if [ $? -ne 0 ]; then
   echo "non e' stata trovata nessuna istanza attiva di apache"
   exit 1
fi
apacheuser="`ps aux | grep 'apache$' | grep -v '^root' | cut -d ' ' -f 1 | sed -n '1,1p'`"

# verifica se lo user e' gia' aggiunto al gruppo voice altrimenti lo aggiunge
id $apacheuser | grep $vgettygroup >/dev/null 2>&1
if [  $? -ne 0 ]; then
   adduser $apacheuser $vgettygroup
fi
apachegroup="`id -g $apacheuser`"

echo "vgetty-group $vgettygroup"
echo "apache-user $apacheuser"
echo "apache-group $apachegroup"
test $STEPBYSTEP && read a

#installa lo script per l'amministrazione dei file audio
desed_dir="`echo "$vgettydir" | sed 's/\([/\&]\)/\\\\\1/g'`"
desed_dir2="`echo "$ADMIN" | sed 's/\([/\&]\)/\\\\\1/g'`"
cat daemon/makewavmsg.sh |\
sed "s/#VGETTYDIR#/$desed_dir/g" |\
sed "s/#ADMIN#/$desed_dir2/g" > $MAKEMSG_PATH/makewavmsg.sh
chmod 744 $MAKEMSG_PATH/makewavmsg.sh
#aggiunge alla crontab di root la riga per il lancio dello script
crontab -l > $TMPFILE
grep makewavmsg.sh $TMPFILE >/dev/null 2>&1
if [  $? -ne 0 ]; then
  echo "*/$OGNIQUANTO * * * *     $MAKEMSG_PATH/makewavmsg.sh"  >> $TMPFILE
  crontab $TMPFILE 
fi

test $STEPBYSTEP && read a

# installa i file per l'applicativo web
install -m 644 php/preferences.php php/ascolta.jpg php/cancella.jpg php/telefono.jpg php/aopowered.gif $PHPFILEPATH
desed_dir="`echo "$wavdir" | sed 's/\([/\&]\)/\\\\\1/g'`"
for fil in index.php dumpmesg.php; do
  sed "s/#PATHOGGEWAV#/$desed_dir/g" < php/$fil > $PHPFILEPATH/$fil
  chmod 644 $PHPFILEPATH/$fil
done
install -m 640 -g $apachegroup php/.htpasswd $PHPFILEPATH

desed_dir="`echo "$PHPFILEPATH" | sed 's/\([/\&]\)/\\\\\1/g'`"
sed "s/#PHPFILEPATH#/$desed_dir/g" < php/.htaccess > $PHPFILEPATH/.htaccess
chmod 644 $PHPFILEPATH/.htaccess

echo "Installazione completata con successo"

exit 0

