#!/bin/bash
#   makewavmsg.sh   script per la gestione dei file audio della
#   Vers. 0.0.5   segreteria telefonica via web.           
#                 Copyright (C)  2002-2004  Matteo Nastasi 
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#     CONTACT:    nastasi@alternativeoutput.it
#                 matteo.nastasi@milug.org

#!/bin/bash
PATH=/usr/local/bin:/usr/bin:/bin:/usr/bin/X11
RMDDIR=#VGETTYDIR#/incoming
WAVDIR=#VGETTYDIR#/incomwav
ADMIN=#ADMIN#
VGETTYLOG=/var/log/mgetty/vg_ttyS1.log
# set -x
# MAIN
lockfile -r 1 /var/lock/makewavmsg.LCK
if [ $? -ne 0 ]; then
   exit 1
fi

# verifico che non sia in atto una chiamata perche' altrimenti
# rischio di convertire soltanto una parte del messaggio in wav e ogg
tail -n 1 $VGETTYLOG | grep ' waiting\.\.\.$' >/dev/null 2>&1
if [ $? -ne 0 ]; then
   rm -f /var/lock/makewavmsg.LCK
   exit 0
fi

IFS='
'
# cerca tutti i corrispettivi .rmd dei .del e li cancella
for i in `ls $WAVDIR/*.del 2>/dev/null`; do
   name="`basename "$i" .del`"
   if [ -f "$RMDDIR/$name.rmd" ]; then
      echo "TROVATO $name.del ed esiste $name.rmd; lo cancello"
      rm "$RMDDIR/$name.rmd"

      # cancella i file audio per il web (wav e ogg)
      if [ -f $WAVDIR/$name.wav ]; then
         rm "$WAVDIR/$name.wav"
      fi
      if [ -f $WAVDIR/$name.ogg ]; then
         rm "$WAVDIR/$name.ogg"
      fi
      # cancella anche il file di comando per la cancellazione
      rm $WAVDIR/$name.del
   fi
done

# crea i .wav e .ogg per la rete
for i in `ls $RMDDIR/*.rmd 2>/dev/null`; do
   # echo "$i"
   name="`basename "$i" .rmd`"
   if [ ! -f "$WAVDIR/$name.wav" ]; then
      echo MANCA "$WAVDIR/$name.wav"
      rmdtopvf "$i" "/tmp/makewavmsg.$$.pvf"
      pvftowav "/tmp/makewavmsg.$$.pvf" "$WAVDIR/$name.wav"
      chmod g+w "$WAVDIR/$name.wav"
      oggenc -Q "$WAVDIR/$name.wav" -o "$WAVDIR/$name.ogg"
      chmod g+w "$WAVDIR/$name.ogg"
      rm "/tmp/makewavmsg.$$.pvf"

      # manda email a chi va informato del nuovo messaggio
      date | mail -s "C'e' un nuovo mesg in segreteria" $ADMIN
   fi
done

rm -f /var/lock/makewavmsg.LCK
exit 0
